=== gemrb/plugins/DirectoryImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (DirectoryImporter DirectoryImporter.cpp)
