=== gemrb/plugins/EFFImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (EFFImporter EFFImporter.cpp)
