=== gemrb/plugins/FXOpcodes/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (FXOpcodes FXOpcodes.cpp)
