=== gemrb/plugins/PVRZImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (PVRZImporter PVRZImporter.cpp)
