=== gemrb/plugins/TISImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (TISImporter TISImporter.cpp)
