=== debian/changelog ===
gemrb (0.9.2+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:39:53 +0000

gemrb (0.9.2+dfsg-1build2) noble; urgency=medium

  * No-change rebuild to build with python3.12 only.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Mar 2024 23:11:14 +0100

gemrb (0.9.2+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:36:27 +0000

gemrb (0.9.2+dfsg-1) unstable; urgency=medium

  * New upstream release:
    - upstream now supports Python 3.12; closes: #1061317;
    - bg2ee files aren’t installed for now, the game isn’t playable yet.
  * Standards-Version 4.6.2, no change required.
  * Add myself as an uploader (I sponsored the previous uploads).

 -- Stephen Kitt <skitt@debian.org>  Wed, 28 Feb 2024 12:54:22 +0100
